#!/bin/sh

# Glossary format is
# 
# Name  Type  Stack relation  Description
# 
# Type is encoded in three letters (TSI), where
# 
# T = Type
# 	A = array
# 	C = constant
# 	M = machine code
# 	T = thread
# 	V = variable
# 
# S = Syntax
# 
# I = I/O (moves >IN)

grep '^\\d ' sol.sol | sed -e 's/^.. //'  >__tmp

sort <__tmp | awk '
BEGIN	{
	FS=" "
	}
	{
	sr=substr($0, index($0, "( "))
	sr=substr(sr, 0, index(sr,")"))
	de=substr($0, index($0, " | ")+3)
	fl=substr($0, index($0, " ) "))
	fl=substr(fl, 4, 4)
	printf "%-9s  %s  %-19s  %s\n", $1, fl, sr, de
	}
' >Glossary

sort <__tmp | awk '
BEGIN	{
	FS=" "
	}
	{
	sr=substr($0, index($0, "( "))
	sr=substr(sr, 0, index(sr,")"))
	de=substr($0, index($0, " | ")+3)
	fl=substr($0, index($0, " ) "))
	fl=substr(fl, 4, 4)
	printf "%s\t%s\t%s\t%s\n", $1, fl, sr, de
	}
' | awk '
BEGIN	{
	FS="\t"
	print "<TABLE>"
	}
	{
	gsub("&", "\\&amp;")
	gsub("<", "\\&lt;")
	gsub(">", "\\&gt;")
	name=$1
	gsub("\"", "~", name)
	gsub("\\\?", "Q", name)
	print " <TR>"
	printf "  <TD><A name=\"G%s\">&nbsp;</A>\n", name
	printf "   <A href=\"hypersol.html#%s\"><TT>%s</TT></A></TD>\n", \
		name, $1
	printf "  <TD>\n   <TT> %s</TT></TD>\n", $2
	printf "  <TD>\n   <TT> %s</TT></TD>\n", $3
	printf "  <TD>\n   <TT> %s</TT></TD>\n", $4
	print " </TR>"
	}
END	{
	print "</TABLE>"
	}
' >Glossary.html

rm -f __tmp

