\ SOL meta compiler
\ By Nils M Holm, 2002,2004,2010

\ To be improved.

\ To build a new SOL kernel, run BUILD
\ To install the new kernel, run 2 INSTALL

: meta-dict ;

sol.kspace const kbot

0 var kspace
0 var m-h
0 var m-last

: m-here ( -- a ) m-h @ ;

: emitc ( c -- ) m-here c!  1 m-h +! ;

: emitw ( n -- ) dup 24 shr emitc  dup 16 shr emitc
  dup 8 shr emitc  emitc ;

: emits ( n -- ) count begin ?while
    over c@ emitc s+ repeat  drop ;

: relocate ( a -- a ) kspace @ - kbot + ;

: unrelocate ( a -- a ) kspace @ + kbot - ;

: emitr ( n -- ) relocate emitw ;

: silent-lookup ( a -- 0|a -1 ) dup locase m-last @ lookup ;

: m-lookup ( a -- a ) dup silent-lookup not if
    space count type abort" not defined" then  nip ;

: m-find ( a -- 0|a -1 ) m-lookup l>code ;

: m-call ( a -- ) emitw ;

: emitt ( a -- ) m-find emitr ;

: emitp ( a -- ) emitt ;

: m-create ( -- ) m-last @ emitw  m-here cell- m-last !
  bl word  dup c@ emitc dup emits c@ emitc ;

: equal ( s1 s2 -- f ) count 1+ swap 1- swap -text 0= ;

: m-next, ( -- ) [hex] 82 emitc ( NEXT ) ;

: hexcomp ( -- ) hex!
  begin bl word dup s" next;" equal not while  case
                dup c@ 0= => dec!  drop  exit ;;
                 dup ?num => emitc ;;
          dup s" \" equal => escape \ ;;
      dup s" next," equal => m-next, ;;
                       else> dec!  abort" syntax error in :H"
    end  drop  repeat  drop  m-next,  dec! ;

: primitive ( -- ) m-create  hexcomp ;

: m-var ( n -- ) m-create  s" (var)" emitp emitw ;

: m-const ( n -- ) m-create  s" (const)" emitp emitw ;

: m-array ( n -- ) m-create  s" (array)" emitp
  dup 0= if drop exit then  for 0 emitw next ;

: m-allot ( n -- ) for 0 emitc next ;

: m-['] ( -- ) s" (lit)" emitt  bl word m-find emitr ;

: m-compile ( -- ) s" (lit)" emitt
  bl word m-find emitr  s" ," emitt ;

: m-lit ( n -- ) s" (lit)" emitt  emitw ;

: m-if ( -- a ) s" (bf)" emitt  m-here  0 emitw ;

: m-then ( a -- ) m-here relocate swap ! ;

: m-else ( -- ) s" (br)" emitt  m-here  0 emitw
  swap m-then ;

: m-repeat ( a a -- ) s" (br)" emitt  swap emitr
  m-then ;

: m-until ( a -- ) s" (bf)" emitt  emitr ;

: m-again ( a -- ) s" (br)" emitt  emitr ;

: m-for ( -- a ) s" >r" emitt  m-here ;

: m-next ( a -- ) s" (next)" emitt
  s" (bf)" emitt  emitr ;

: m-do ( -- a ) s" (do)" emitt  m-here ;

: m-loop ( a -- ) s" (loop)" emitt
  s" (bf)" emitt  emitr ;

: m-case ( -- 0 ) 0 ;

: m-=> ( -- a ) m-if ;

: m-;; ( -- ) m-else ;

: m-end ( a ... 0 -- ) begin ?while m-then repeat ;

: m-[char] ( -- ) s" (lit)" emitt  bl word 1+ c@ emitw ;

: m-hex ( -- n ) hex! #in dec! ;

: m-[hex] ( -- ) s" (lit)" emitt  m-hex emitw ;

: (save|) ( -- a ) here  [char] | word c@ cell+ 1+ allot ;

: s| ( -- a ) (save|)  ['] (s") swap ! ; syntax

: m-abort" ( -- ) s| (abort")| emitt
  [char] " word  dup c@ emitc emits ;

: m-." ( -- ) s| (.")| emitt
  [char] " word  dup c@ emitc emits ;

: m-s" ( -- ) s| (s")| emitt
  [char] " word  dup c@ emitc emits ;

: immed ( a -- f ) >name c@ 128 and ;

: m-escape ( a -- a ) bl word m-find  dup immed not if
    space >name count type abort" unknown syntax word" then
  emitr ;

: tcomp ( a -- ) dup silent-lookup not if
    dup ?num if  m-lit drop  else m-find then
  else  l>code emitr drop then ;

: mcomp4 ( a -- ) case
    dup s| abort"| equal => drop m-abort" ;;
    dup s| ."| equal     => drop m-." ;;
    dup s| s"| equal     => drop m-s" ;;
                      else> tcomp
  end ;

: mcomp3 ( a -- ) case
    dup s" loop" equal   => drop m-loop ;;
    dup s" case" equal   => drop m-case ;;
    dup s" =>" equal     => drop m-=> ;;
    dup s" else>" equal  => drop ;;
    dup s" ;;" equal     => drop m-;; ;;
    dup s" end" equal    => drop m-end ;;
    dup s" [char]" equal => drop m-[char] ;;
    dup s" [hex]" equal  => drop m-[hex] ;;
                      else> mcomp4
  end ;

: mcomp2 ( a -- ) case
    dup s" begin" equal  => drop m-here ;;
    dup s" while" equal  => drop m-if ;;
    dup s" repeat" equal => drop m-repeat ;;
    dup s" until" equal  => drop m-until ;;
    dup s" again" equal  => drop m-again ;;
    dup s" for" equal    => drop m-for ;;
    dup s" next" equal   => drop m-next ;;
    dup s" do" equal     => drop m-do ;;
                      else> mcomp3
  end ;

: mcomp1 ( -- ) case
    dup s" \" equal       => drop escape \ ;;
    dup s" (" equal       => drop escape ( ;;
    dup s" escape" equal  => drop m-escape ;;
    dup s" [']" equal     => drop m-['] ;;
    dup s" compile" equal => drop m-compile ;;
    dup s" if" equal      => drop m-if ;;
    dup s" else" equal    => drop m-else ;;
    dup s" then" equal    => drop m-then ;;
                       else> mcomp2
  end ;

: m-: ( -- ) m-create  s" (:)" emitp
  begin bl word dup s" ;" equal not while  case
      dup c@ 0= => abort" missing ; after :" ;;
             else> mcomp1
    end  repeat  drop  s" exit" emitt ;

: m-alias ( a -- ) m-create
  [hex] 8a ( REDIR ) emitc  emitw ;

: m-syntax ( -- ) m-last @ l>code >name
  dup c@ 128 or swap c! ;

: m-defer ( -- ) m-create  s" (:)" emitp
  s" exit" emitt  \ should be s" (defer)"
  s" exit" emitt ;

: m-is ( a -- ) bl word m-find cell+ ! ;

: m->link ( a -- a) unrelocate >link relocate ;

: va ( -- a ) s" (var)" m-find relocate ;

: ca ( -- a ) s" (const)" m-find relocate ;

: findvar ( a -- )
  m-find dup @ ( cfa: code-ptr )
  dup va = if  drop 4 +   exit then
  dup ca = if  drop 4 + @ exit then
  drop  space >name count 127 and type
  abort" - syntax error" ;

: mint3 ( a -- ) case
     dup s" syntax" equal => drop m-syntax ;;
     dup s" defer" equal  => drop m-defer ;;
     dup s" is" equal     => drop m-is ;;
     dup s" hex" equal    => drop m-hex ;;
     dup s" neg" equal    => drop neg ;;
     dup s" -" equal      => drop - ;;
     dup s" here" equal   => drop m-here relocate ;;
     dup s" >link" equal  => drop m->link ;;
     dup s" 'sol" equal   => drop kspace @ cell+ ;;
                       else> findvar
  end ;

: mint2 ( a -- ) case
     dup s" const" equal => drop m-const ;;
     dup s" array" equal => drop m-array ;;
     dup s" value" equal => drop m-const ;;
     dup s" allot" equal => drop m-allot ;;
     dup s" '" equal     => drop bl word m-find relocate ;;
     dup s" ," equal     => drop emitw ;;
     dup s" c," equal    => drop emitc ;;
     dup s" !" equal     => drop ! ;;
     dup s" :" equal     => drop m-: ;;
     dup s" alias" equal => drop m-alias ;;
                      else> mint3
  end ;

: mint1 ( a -- ) case
     dup s" \d" equal  => drop escape \d ;;
     dup s" \" equal   => drop escape \ ;;
     dup s" (" equal   => drop escape ( ;;
     dup s" (l" equal  => drop escape (l ;;
     dup s" :h" equal  => drop primitive ;;
     dup s" h]" equal  => drop hexcomp ;;
     dup ?num          => nip ;;
     dup s" var" equal => drop m-var ;;
                    else> mint2
  end ;

: fixup ( -- ) sol.kspace  s" sol.kspace" m-find >pfa !
  m-last @ begin  dup @ 0= if drop exit then
    dup @ swap  dup @ relocate swap !  again ;

: meta-compile ( blk -- )
  0 m-last !  here 1024 + m-h !  m-here kspace !
  kspace @ top u>= if abort" not enough space" then
  begin dup .  block  ?lhdr
    dup >buf !  dup >in !  b/blk + >lim !
    begin bl word dup c@ while
      mint1  repeat  drop
  l> @ dup 0= until drop  fixup ;

: ksize ( -- n ) m-here kspace @ -  b/blk 1- +  b/blk / ;

: build ( -- )
  src@  sol.scr meta-compile  src!
  cr ." size =" ksize .
  ksize 65536 > if abort" kernel too big" then ;

: install ( 1|2 -- )
  ksize 1 do i  over 2 = if  sol.ksize + then
    dup .  i 1- b/blk * kspace @ + write  loop  drop ;
